{% extends "base.html" %}
{% set active_page = "launch" %}
{% block body %}
<form action="/launch" id="uploadForm" method="POST" enctype=multipart/form-data>
    <fieldset class="uk-fieldset">

        <legend class="uk-legend">Launch a Workflow</legend>

        <div class="uk-margin">
            <label>Workflow Type:</label>
            <br>
            <div>
              <input type="radio" name="type" id="somatic_illumina_solid" value="somatic-illumina-solid" >
              <label for="somatic_illumina_solid">Solid tumors (Illumina)</label>
              <div class="reveal-if-active">
                <label for="somatic-illumina-solid-input1">Fastq 1:</label> 
                <input type="file" id="somatic-illumina-solid-input1" name="somatic_illumina_solid_fastq1" class="require-if-active" data-require-pair="#somatic_illumina_solid">
                <br>
                <label for="somatic-illumina-solid-input2">Fastq 2:</label>
                <input type="file" id="somatic-illumina-solid-input2" name="somatic_illumina_solid_fastq2" class="require-if-active" data-require-pair="#somatic_illumina_solid">
              </div>
            </div>

            <div>
              <input type="radio" name="type" id="somatic_torrent_solid"  value="somatic-torrent-solid">
              <label for="somatic_torrent_solid">Solid tumors (Ion Torrent)</label>
              <div class="reveal-if-active">
                <label for="somatic-torrent-solid-input1">Bam:</label>
                <input type="file" id="somatic-torrent-solid-input1" name="somatic_torrent_solid_bam" class="require-if-active" data-require-pair="#somatic_torrent_solid">
                <br>
                <label for="somatic-torrent-solid-input2">Bed (Optional):</label>
                <input type="file" id="somatic-torrent-solid-input2" name="somatic_torrent_solid_bed" class="require-if-active"  data-require-pair="#somatic_torrent_solid">
                <br>
                <label for="somatic-torrent-solid-input3">JSON Params (Optional):</label>
                <input type="file" id="somatic-torrent-solid-input3" name="somatic_torrent_solid_parameters" class="require-if-active"  data-require-pair="#somatic_torrent_solid">
              </div>
            </div>

            <div>
              <input type="radio" name="type" id="somatic_illumina_hematologic" value="somatic-illumina-hematologic" required>
              <label for="somatic_illumina_hematologic">Hematologic malignancies (Illumina)</label>
              <div class="reveal-if-active">
                <label for="somatic-illumina-hematologic-input1">Fastq 1:</label>
                <input type="file" id="somatic-illumina-hematologic-input1" name="somatic_illumina_hematologic_fastq1" class="require-if-active" data-require-pair="#somatic_illumina_hematologic">
                <br>
                <label for="somatic-illumina-hematologic-input2">Fastq 2:</label>
                <input type="file" id="somatic-illumina-hematologic-input2" name="somatic_illumina_hematologic_fastq2" class="require-if-active" data-require-pair="#somatic_illumina_hematologic">
              </div>
            </div>

            <div>
              <input type="radio" name="type" id="somatic_torrent_hematologic"  value="somatic-torrent-hematologic">
              <label for="somatic_torrent_hematologic">Hematologic malignancies (Ion Torrent)</label>
              <div class="reveal-if-active">
                <label for="somatic-torrent-hematologic-input1">Bam:</label>
                <input type="file" id="somatic-torrent-hematologic-input1" name="somatic_torrent_hematologic_bam" class="require-if-active" data-require-pair="#somatic_torrent_hematologic">
                <br>
                <label for="somatic-torrent-hematologic-input2">Bed (Optional):</label>
                <input type="file" id="somatic-torrent-hematologic-input2" name="somatic_torrent_hematologic_bed" class="require-if-active"  data-require-pair="#somatic_torrent_hematologic">
                <br>
                <label for="somatic-torrent-hematologic-input3">JSON Params (Optional):</label>
                <input type="file" id="somatic-torrent-hematologic-input3" name="somatic_torrent_hematologic_parameters" class="require-if-active"  data-require-pair="#somatic_torrent_hematologic">
              </div>
            </div>
            
            <div>
              <input type="radio" name="type" id="hereditary_cancer" value="hereditary-cancer">
              <label for="hereditary_cancer">Hereditary-cancer</label>
              <div class="reveal-if-active">
                <label for="hereditary-cancer-input1">Fastq 1:</label> 
                <input type="file" id="hereditary-cancer-input1" name="hereditary_cancer_fastq1" class="require-if-active" class="require-if-active"  data-require-pair="#hereditary_cancer">
                <br>
                <label for="hereditary-cancer-input2">Fastq 2:</label>
                <input type="file" id="hereditary-cancer-input2" name="hereditary_cancer_fastq2" class="require-if-active" class="require-if-active" data-require-pair="#hereditary_cancer">
              </div>
            </div>
        </div>

        <div class="uk-margin">
            <label>Referral number (Αριθμός Παραπεμπτικού): <input name="orderId" class="uk-input" type="text" placeholder="Order Id" id="orderId"></label>
        </div>
        {% block content %}
            {% if status is defined%}
                <br>
                {{ status }}
                <br> <br>         
            {% endif %}
        {% endblock %}
        <div class="uk-margin" id="statusText" style="display:none">
          Something went wrong. Please try again.
        </div>
        <button type="submit" id="submitButton"  class="uk-button uk-button-primary uk-button-large">Submit</button>
        <div class="uk-margin" id="uploadingText" style="display:none">
          Uploading the files, please wait.
        </div>
        <div class="w3-light-grey" id="progressBar" style="display:none">
          <div class="w3-blue" id="progressBarFill" role="progressbar" style="width: 0%" aria-valuenow="0" aria-valuemin="0" aria-valuemax="100">
            <span class="progress-bar-text" id="progressBarText">0%</span>
          </div>
        </div>
    
      </fieldset>
</form>

  
      <script>
        var uploadForm = document.getElementById("uploadForm");
        var progressBar = document.getElementById("progressBar");
        var progressBarFill = document.getElementById("progressBarFill");
        var progressBarText = document.getElementById("progressBarText");
        var statusText = document.getElementById("statusText")
        var uploadText = document.getElementById("uploadingText");
        var submitButton = document.getElementById("submitButton");
        uploadForm.addEventListener("submit", uploadFile);
        
        function uploadFile (e) {
          e.preventDefault();
          var xhr_orderid = new XMLHttpRequest();
          if (checkOrderId() == false){
              statusText.innerText = "Invalid Referral Number!\n The Referral Number must be of the form XXXX-XXXXX-XXXX where X is any digit";
              statusText.style.display = '';
              return;
          }
          xhr_orderid.open("POST", "/checkorderid");
          xhr_orderid.onreadystatechange = function() {
            if (xhr_orderid.readyState == XMLHttpRequest.DONE && xhr_orderid.status == 200) {
              if (xhr_orderid.responseText == "taken") {
                statusText.style.display = '';
                statusText.innerText = "This Referral Number is already taken!";
              }
              else if (xhr_orderid.responseText == "not_taken"){
                  sendForm();
              }
              else {
                statusText.style.display = '';
                statusText.innerText = xhr_orderid.responseText;
              }
            }
          }
          var miniForm = new FormData();
          miniForm.append("orderId", document.getElementById("orderId").value);
          xhr_orderid.send(miniForm);
        }

        function sendForm(){
          var xhr = new XMLHttpRequest();
          xhr.open("POST", "/launch");
          xhr.upload.addEventListener("progress", e => {
            console.log(e);
            const percent =  e.lengthComputable ? (e.loaded / e.total) * 100 : 0;

            progressBarFill.style.width = percent.toFixed(2) + "%";
            progressBarText.textContent = percent.toFixed(2) + "%";
            if (percent == 100){
              statusText.style.display = '';
            }
          });

          statusText.style.display = 'none';
          xhr.onreadystatechange = function() {
            if (xhr.readyState == XMLHttpRequest.DONE && xhr.status == 200) {
              if (xhr.status == 200){
                statusText.innerText =xhr.responseText;
              }
              statusText.style.display = '';
              uploadText.style.display = 'none'
              progressBar.style.display = 'none'
              submitButton.style.display = '';
            }
          }

          data = new FormData(uploadForm);
          showProgressBar();
          xhr.send(data);
        }


        function showProgressBar() {
          if (uploadText.style.display == 'none') {
            uploadText.style.display = '';
          }
          if (progressBar.style.display == 'none') {
            progressBar.style.display = '';
          }
          submitButton.style.display = 'none';
        }

        var FormStuff = {
          init: function() {
            this.applyConditionalRequired();
            this.bindUIActions();
          },
          bindUIActions: function() {
            $("input[type='radio'], input[type='checkbox']").on("change", this.applyConditionalRequired);
          },
          applyConditionalRequired: function() {
            $(".require-if-active").each(function() {
              var el = $(this);
              if ($(el.data("require-pair")).is(":checked")) {
                el.prop("required", true);
              } else {
                el.val(''); 
                el.prop("required", false);
              }
            });
          }
        };
        FormStuff.init();

        function checkOrderId() {
          var numbers = /^[0-9]{4}-[0-9]{5}-[0-9]{4}$/;
          var orderId;
          orderId = document.getElementById("orderId").value;
          document.getElementById("orderId").value = orderId.trim()
          orderId = document.getElementById("orderId").value;
          if(!orderId.match(numbers)){
            return false;
          }
          else {
            return true;
          }
        }
       
    </script>
{% endblock %}


